OGRE: Ogre::Resource Class Reference - OGRE Documentation

# Ogre::Resource Class Reference

Abstract class representing a loadable resource (e.g. More...

`#include <OgreResource.h>`

Inheritance diagram for Ogre::Resource:

[legend]

List of all members.

## Public Types
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
## Public Member Functions
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | prepare ()
| Prepares the resource for load, if it is not already.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | reload (void)
| Reloads the resource, if it is already loaded.
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual const String & | getName (void) const
| Gets resource name.
virtual ResourceHandle | getHandle (void) const
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual const String & | getGroup (void)
| Gets the group which this resource is a member of.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
virtual const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireBackgroundLoadingComplete (void)
| Firing of background loading complete event.
virtual void | _fireBackgroundPreparingComplete (void)
| Firing of background preparing complete event.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
## Protected Types
typedef std::list< Listener * > | ListenerList
## Protected Member Functions
| Resource ()
| Protected unnamed constructor to prevent default construction.
virtual void | preLoadImpl (void)
| Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.
virtual void | postLoadImpl (void)
| Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.
virtual void | preUnloadImpl (void)
| Internal hook to perform actions before the unload process.
virtual void | postUnloadImpl (void)
| Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.
virtual void | prepareImpl (void)
| Internal implementation of the meat of the 'prepare' action.
virtual void | unprepareImpl (void)
| Internal function for undoing the 'prepare' action.
virtual void | loadImpl (void)=0
| Internal implementation of the meat of the 'load' action, only called if this resource is not being loaded from a ManualResourceLoader.
virtual void | unloadImpl (void)=0
| Internal implementation of the 'unload' action; called regardless of whether this resource is being loaded from a ManualResourceLoader.
virtual size_t | calculateSize (void) const =0
| Calculate the size of a resource; this will only be called after 'load'.
virtual void | queueFireBackgroundLoadingComplete (void)
| Queue the firing of background loading complete event.
virtual void | queueFireBackgroundPreparingComplete (void)
| Queue the firing of background preparing complete event.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
## Protected Attributes
ResourceManager * | mCreator
| Creator.
String | mName
| Unique name of the resource.
String | mGroup
| The name of the resource group.
ResourceHandle | mHandle
| Numeric handle for more efficient look up than name.
AtomicScalar< LoadingState > | mLoadingState
| Is the resource currently loaded?
volatile bool | mIsBackgroundLoaded
| Is this resource going to be background loaded? Only applicable for multithreaded.
size_t | mSize
| The size of the resource in bytes.
bool | mIsManual
| Is this file manually loaded?
String | mOrigin
| Origin of this resource (e.g. script name) - optional.
ManualResourceLoader * | mLoader
| Optional manual loader; if provided, data is loaded from here instead of a file.
size_t | mStateCount
| State count, the number of times this resource has changed state.
ListenerList | mListenerList
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).
## Static Protected Attributes
static ParamDictionaryMap | msDictionary
| Dictionary of parameters.
## Classes
class | Listener

## Detailed Description

Abstract class representing a loadable resource (e.g.

textures, sounds etc)

Remarks:
  Resources are data objects that must be loaded and managed throughout an application. A resource might be a mesh, a texture, or any other piece of data - the key thing is that they must be identified by a name which is unique, must be loaded only once, must be managed efficiently in terms of retrieval, and they may also be unloadable to free memory up when they have not been used for a while and the memory budget is under stress.

  All Resource instances must be a member of a resource group; see ResourceGroupManager for full details.

  Subclasses must implement:
  1. A constructor, overriding the same parameters as the constructor defined by this class. Subclasses are not allowed to define constructors with other parameters; other settings must be settable through accessor methods before loading.
  2. The loadImpl() and unloadImpl() methods - mSize must be set after loadImpl()
  3. StringInterface ParamCommand and ParamDictionary setups in order to allow setting of core parameters (prior to load) through a generic interface.

Definition at line 72 of file OgreResource.h.

## Member Typedef Documentation

typedef std::list<Listener*> Ogre::Resource::ListenerList`[protected]`

Definition at line 148 of file OgreResource.h.

## Member Enumeration Documentation

enum Ogre::Resource::LoadingState

Enum identifying the loading state of the resource.

Enumerator:

  LOADSTATE_UNLOADED | Not loaded.
  LOADSTATE_LOADING | Loading is in progress.
  LOADSTATE_LOADED | Fully loaded.
  LOADSTATE_UNLOADING | Currently unloading.
  LOADSTATE_PREPARED | Fully prepared.
  LOADSTATE_PREPARING | Preparing is in progress.

Definition at line 109 of file OgreResource.h.

## Constructor & Destructor Documentation

Ogre::Resource::Resource | ( |  | ) | `[protected]`

Protected unnamed constructor to prevent default construction.

Definition at line 154 of file OgreResource.h.

Ogre::Resource::Resource | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0` |
| ) |  |  |

Standard constructor.

Parameters:

  | creator | Pointer to the ResourceManager that is creating this resource
  | name | The unique name of the resource
  | group | The name of the resource group to which this resource belongs
  | isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  | loader | Pointer to a ManualResourceLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualResourceLoader instance is strongly recommended.

virtual Ogre::Resource::~Resource | ( |  | ) | `[virtual]`

Virtual destructor.

Shouldn't need to be overloaded, as the resource deallocation code should reside in unload()

See also:
  Resource::unload()

## Member Function Documentation

virtual void Ogre::Resource::preLoadImpl | ( | void |  | ) | `[protected, virtual]`

Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Definition at line 166 of file OgreResource.h.

virtual void Ogre::Resource::postLoadImpl | ( | void |  | ) | `[protected, virtual]`

Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Reimplemented in Ogre::Mesh.

Definition at line 173 of file OgreResource.h.

virtual void Ogre::Resource::preUnloadImpl | ( | void |  | ) | `[protected, virtual]`

Internal hook to perform actions before the unload process.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 178 of file OgreResource.h.

virtual void Ogre::Resource::postUnloadImpl | ( | void |  | ) | `[protected, virtual]`

Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 183 of file OgreResource.h.

virtual void Ogre::Resource::prepareImpl | ( | void |  | ) | `[protected, virtual]`

Internal implementation of the meat of the 'prepare' action.

Reimplemented in Ogre::Material, Ogre::Mesh, and Ogre::PatchMesh.

Definition at line 187 of file OgreResource.h.

virtual void Ogre::Resource::unprepareImpl | ( | void |  | ) | `[protected, virtual]`

Internal function for undoing the 'prepare' action.

Called when the load is completed, and when resources are unloaded when they are prepared but not yet loaded.

Reimplemented in Ogre::Material, and Ogre::Mesh.

Definition at line 192 of file OgreResource.h.

virtual void Ogre::Resource::loadImpl | ( | void |  | ) | `[protected, pure virtual]`

Internal implementation of the meat of the 'load' action, only called if this resource is not being loaded from a ManualResourceLoader.

Implemented in Ogre::Compositor, Ogre::Font, Ogre::GpuProgram, Ogre::HighLevelGpuProgram, Ogre::Material, Ogre::Mesh, Ogre::PatchMesh, Ogre::Skeleton, and Ogre::SkeletonInstance.

virtual void Ogre::Resource::unloadImpl | ( | void |  | ) | `[protected, pure virtual]`

Internal implementation of the 'unload' action; called regardless of whether this resource is being loaded from a ManualResourceLoader.

Implemented in Ogre::Compositor, Ogre::Font, Ogre::HighLevelGpuProgram, Ogre::Material, Ogre::Mesh, Ogre::Skeleton, Ogre::SkeletonInstance, and Ogre::Texture.

virtual size_t Ogre::Resource::calculateSize | ( | void |  | ) | const`[protected, pure virtual]`

Calculate the size of a resource; this will only be called after 'load'.

Implemented in Ogre::Compositor, Ogre::Font, Ogre::GpuProgram, Ogre::Material, Ogre::Mesh, Ogre::Skeleton, and Ogre::Texture.

virtual void Ogre::Resource::queueFireBackgroundLoadingComplete | ( | void |  | ) | `[protected, virtual]`

Queue the firing of background loading complete event.

virtual void Ogre::Resource::queueFireBackgroundPreparingComplete | ( | void |  | ) | `[protected, virtual]`

Queue the firing of background preparing complete event.

virtual void Ogre::Resource::prepare | ( |  | ) | `[virtual]`

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) | `[virtual]`

Loads the resource, if it is not already.

Remarks:
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters:

  | backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::reload | ( | void |  | ) | `[virtual]`

Reloads the resource, if it is already loaded.

Remarks:
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const`[virtual]`

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 271 of file OgreResource.h.

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const`[virtual]`

Is this resource manually loaded?

Definition at line 278 of file OgreResource.h.

virtual void Ogre::Resource::unload | ( | void |  | ) | `[virtual]`

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const`[virtual]`

Retrieves info about the size of the resource.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 290 of file OgreResource.h.

virtual void Ogre::Resource::touch | ( | void |  | ) | `[virtual]`

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::Material, and Ogre::UnifiedHighLevelGpuProgram.

Referenced by Ogre::Material::touch().

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const`[virtual]`

Gets resource name.

Reimplemented in Ogre::SkeletonInstance.

Definition at line 301 of file OgreResource.h.

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const`[virtual]`

Reimplemented in Ogre::SkeletonInstance.

Definition at line 306 of file OgreResource.h.

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const`[virtual]`

Returns true if the Resource has been prepared, false otherwise.

Definition at line 313 of file OgreResource.h.

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const`[virtual]`

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 321 of file OgreResource.h.

virtual bool Ogre::Resource::isLoading | ( |  | ) | const`[virtual]`

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 330 of file OgreResource.h.

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const`[virtual]`

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 337 of file OgreResource.h.

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const`[virtual]`

Returns whether this Resource has been earmarked for background loading.

Remarks:
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 354 of file OgreResource.h.

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) | `[virtual]`

Tells the resource whether it is background loaded or not.

Remarks:

See also:
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 364 of file OgreResource.h.

virtual void Ogre::Resource::escalateLoading | ( |  | ) | `[virtual]`

Escalates the loading of a background loaded resource.

Remarks:
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) | `[virtual]`

Register a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) | `[virtual]`

Remove a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | `[virtual]`

Gets the group which this resource is a member of.

Reimplemented in Ogre::SkeletonInstance.

Definition at line 388 of file OgreResource.h.

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) | `[virtual]`

Change the resource group ownership of a Resource.

Remarks:
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters:

  | newGroup | Name of the new group

virtual ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) | `[virtual]`

Gets the manager which created this resource.

Definition at line 400 of file OgreResource.h.

virtual const String& Ogre::Resource::getOrigin | ( | void |  | ) | const`[virtual]`

Get the origin of this resource, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

Definition at line 407 of file OgreResource.h.

virtual void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) | `[virtual]`

Notify this resource of it's origin.

Definition at line 409 of file OgreResource.h.

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const`[virtual]`

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

Definition at line 418 of file OgreResource.h.

virtual void Ogre::Resource::_dirtyState | ( |  | ) | `[virtual]`

Manually mark the state of this resource as having been changed.

Remarks:
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also:
  getStateCount.

virtual void Ogre::Resource::_fireBackgroundLoadingComplete | ( | void |  | ) | `[virtual]`

Firing of background loading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

virtual void Ogre::Resource::_fireBackgroundPreparingComplete | ( | void |  | ) | `[virtual]`

Firing of background preparing complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 176 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 200 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

Definition at line 213 of file OgreStringInterface.h.

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 269 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 300 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

ResourceManager* Ogre::Resource::mCreator`[protected]`

Creator.

Definition at line 126 of file OgreResource.h.

String Ogre::Resource::mName`[protected]`

Unique name of the resource.

Definition at line 128 of file OgreResource.h.

String Ogre::Resource::mGroup`[protected]`

The name of the resource group.

Definition at line 130 of file OgreResource.h.

ResourceHandle Ogre::Resource::mHandle`[protected]`

Numeric handle for more efficient look up than name.

Definition at line 132 of file OgreResource.h.

AtomicScalar<LoadingState> Ogre::Resource::mLoadingState`[protected]`

Is the resource currently loaded?

Definition at line 134 of file OgreResource.h.

volatile bool Ogre::Resource::mIsBackgroundLoaded`[protected]`

Is this resource going to be background loaded? Only applicable for multithreaded.

Definition at line 136 of file OgreResource.h.

size_t Ogre::Resource::mSize`[protected]`

The size of the resource in bytes.

Definition at line 138 of file OgreResource.h.

bool Ogre::Resource::mIsManual`[protected]`

Is this file manually loaded?

Definition at line 140 of file OgreResource.h.

String Ogre::Resource::mOrigin`[protected]`

Origin of this resource (e.g. script name) - optional.

Definition at line 142 of file OgreResource.h.

ManualResourceLoader* Ogre::Resource::mLoader`[protected]`

Optional manual loader; if provided, data is loaded from here instead of a file.

Definition at line 144 of file OgreResource.h.

size_t Ogre::Resource::mStateCount`[protected]`

State count, the number of times this resource has changed state.

Definition at line 146 of file OgreResource.h.

ListenerList Ogre::Resource::mListenerList`[protected]`

Definition at line 149 of file OgreResource.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, protected, inherited]`

Dictionary of parameters.

Definition at line 161 of file OgreStringInterface.h.

String Ogre::StringInterface::mParamDictName`[protected, inherited]`

Class name for this instance to be used as a lookup (must be initialised by subclasses).

Definition at line 164 of file OgreStringInterface.h.

The documentation for this class was generated from the following file:

- OgreResource.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:35:41 2009